#include <stdio.h>
#include <string.h>
#include <sys/mman.h>

extern void sn(void), sn_end(void);
extern unsigned long long out[4][2];
extern unsigned long long all_tmp[16][2];

unsigned long long init_out[4][2], exp_out[4][2];

static unsigned char code[0x1000] __attribute__((aligned(4096)));

static unsigned int timeit(void)
{
	void (*codeptr)() = (void (*))code;
	unsigned int start, end, t, min;
	int i, j;

	strcpy((char *)&all_tmp[1][0],
		"This is free software with ABSOLUTELY NO WARRANTY.");

	min = ~0;
	for (i = 0; i < 21; i++) {
		t = 0;
		for (j = 0; j < 10; j++) {
			memcpy(out, init_out, sizeof(out));
			__asm__ __volatile__("rdtsc" : "=a" (start) :: "dx");
			codeptr();
			__asm__ __volatile__("rdtsc" : "=a" (end) :: "dx");
			t += end - start;
		}
		if (t < min) min = t;
	}
	return min;
}

static unsigned char *insns[0x100];
static int insizes[0x100];
static int incount;

static int swap[0x100];

void init(void) {
	unsigned char *p = (unsigned char *)sn;

	mprotect(code, sizeof(code), PROT_READ|PROT_WRITE|PROT_EXEC);

	incount = 0;
	while (p < (unsigned char *)sn_end - 1) {
		swap[incount] = incount;
		insns[incount] = p;
		p = memchr(p + 1, 0x66, (unsigned char *)sn_end - p);
		if (!p) p = (unsigned char *)sn_end - 1;
		insizes[incount] = p - insns[incount];
		incount++;
	}
	swap[incount] = incount;
	insns[incount] = p;
	insizes[incount++] = 1;

	init_out[0][0] = 0x32db622fb455ded0;
	init_out[1][0] = 0x8d2c0282a92c37f7;
	init_out[2][0] = 0x1656dc16482d0d67;
	init_out[3][0] = 0xc886fd4110949d32;
	init_out[0][1] = init_out[0][0];
	init_out[1][1] = init_out[1][0];
	init_out[2][1] = init_out[2][0];
	init_out[3][1] = init_out[3][0];
	exp_out[0][0] = 0xcedb59be62d032e9;
	exp_out[1][0] = 0xbc739bed0991fc6c;
	exp_out[2][0] = 0x1015c7ee078890a0;
	exp_out[3][0] = 0x4924477bc94370d6;
	exp_out[0][1] = exp_out[0][0];
	exp_out[1][1] = exp_out[1][0];
	exp_out[2][1] = exp_out[2][0];
	exp_out[3][1] = exp_out[3][0];
}

int try(void)
{
	int i, j;
	unsigned char *p;

	p = code;
	for (i = 0; i < incount - 1; i++) {
		j = swap[i];
		memcpy(p, insns[j], insizes[j]);
		if (i != j &&
		    !memcmp(p, insns[i], insizes[j]))
			return 0;
		p += insizes[j];
	}
	memcpy(p, insns[incount - 1], insizes[incount - 1]);
	return 1;
}

void loop(void)
{
	int i, j, k;
	unsigned int t0, t, tb, tbm;

	try();
	t0 = timeit();
	printf("%u\n", t0);
	if (memcmp(out, exp_out, sizeof(out)))
		printf("%llx %llx %llx %llx\n", out[0][0], out[1][0], out[2][0], out[3][0]);

	for (j = 1; j < 100; j++)
	for (i = 6; i < incount - 1 - j; i++) {
		swap[i] = i + j;
		swap[i + j] = i;
		if (try())
			t = timeit();
		else
			t = 9999;
		if (t < 9999 && !memcmp(out, exp_out, sizeof(out))) {
			int a1 = i, a2 = i + j;
			tb = t; tbm = 9999;
			{
				int i, j;
				for (j = 1; j < 100; j++)
				for (i = 6; i < incount - 1 - j; i++) {
					unsigned int txm;
					int b1 = i, b2 = i + j;
					if (b1 == a1 || b1 == a2 || b2 == a1 || b2 == a2)
						continue;
					swap[i] = i + j;
					swap[i + j] = i;
					if (try())
						txm = timeit();
					else
						txm = 9999;
					if (txm < 9999 && !memcmp(out, exp_out, sizeof(out))) {
						int i, j;
						unsigned int tx;
						for (j = 1; j < 100; j++)
						for (i = 6; i < incount - 1 - j; i++) {
							int c1 = i, c2 = i + j;
							if (c1 == a1 || c1 == a2 ||
							    c2 == a1 || c2 == a2 ||
							    c1 == b1 || c1 == b2 ||
							    c2 == b1 || c2 == b2)
								continue;
							swap[i] = i + j;
							swap[i + j] = i;
							if (try())
								tx = timeit();
							else
								tx = 9999;
							if (tx < tb &&
							    !memcmp(out, exp_out, sizeof(out))) {
								tb = tx;
								tbm = txm;
							}
							swap[i] = i;
							swap[i + j] = i + j;
						}
					}
					swap[i] = i;
					swap[i + j] = i + j;
				}
			}
			if (tb < t0) {
				printf("%d: %u,%u,%u - %d:", j, t, tbm, tb, i);
				for (k = 0; k < insizes[i]; k++)
					printf(" %02x", insns[i][k]);
				printf("\n");
			}
		}

		swap[i] = i;
		swap[i + j] = i + j;
	}
}

int main(void) {
	init();
	loop();

	return 0;
}
