#include <stdio.h>
#include <string.h>
#include <sys/mman.h>

extern void sn(void), sn_end(void);
extern unsigned long long out[4];
extern unsigned long long all_tmp[16];

unsigned long long init_out[4], exp_out[4];

static unsigned char code[0x1000] __attribute__((aligned(4096)));

static unsigned int timeit(void)
{
	void (*codeptr)() = (void (*))code;
	unsigned int start, end, t, min;
	int i;

	strcpy((char *)&all_tmp[1],
		"This is free software with ABSOLUTELY NO WARRANTY.");
	memcpy(out, init_out, sizeof(out));

	min = ~0;
	for (i = 0; i < 3; i++) {
		__asm__ __volatile__("rdtsc" : "=a" (start) :: "dx");
		codeptr();
		__asm__ __volatile__("rdtsc" : "=a" (end) :: "dx");
		t = end - start;
		if (t < min) min = t;
	}
	return min;
}

static unsigned char *insns[0x100];
static int insizes[0x100];
static int incount;

static int swap[0x100];

void init(void) {
	unsigned char *p = (unsigned char *)sn;

	mprotect(code, sizeof(code), PROT_READ|PROT_WRITE|PROT_EXEC);

	incount = 0;
	while (p < (unsigned char *)sn_end - 1) {
		swap[incount] = incount;
		insns[incount] = p;
		p = memchr(p + 1, 0x0f, (unsigned char *)sn_end - p);
		if (!p) p = (unsigned char *)sn_end - 1;
		insizes[incount] = p - insns[incount];
		incount++;
	}
	swap[incount] = incount;
	insns[incount] = p;
	insizes[incount++] = 1;

	init_out[0] = 0x32db622fb455ded0ULL;
	init_out[1] = 0x8d2c0282a92c37f7ULL;
	init_out[2] = 0x1656dc16482d0d67ULL;
	init_out[3] = 0xc886fd4110949d32ULL;
	exp_out[0] = 0xcedb59be62d032e9ULL;
	exp_out[1] = 0xbc739bed0991fc6cULL;
	exp_out[2] = 0x1015c7ee078890a0ULL;
	exp_out[3] = 0x4924477bc94370d6ULL;
/* S5
	exp_out[0] = 0x4367aca8049a54c8ULL;
	exp_out[1] = 0x08f0f6ec8b168cf4ULL;
	exp_out[2] = 0xe5cbed6b3a17e37dULL;
	exp_out[3] = 0x8b9ea6ad0d790554ULL;
// S8
	exp_out[0] = 0xd326c790c44fa8d1ULL;
	exp_out[1] = 0x40366e7ec4d11011ULL;
	exp_out[2] = 0xc1b7a1fed8da2d7dULL;
	exp_out[3] = 0x368584104221a8a8ULL;
*/
}

int try(void)
{
	int i, j;
	unsigned char *p;

	p = code;
	for (i = 0; i < incount - 1; i++) {
		j = swap[i];
		memcpy(p, insns[j], insizes[j]);
		if (i != j &&
		    !memcmp(p, insns[i], insizes[j]))
			return 0;
		p += insizes[j];
	}
	memcpy(p, insns[incount - 1], insizes[incount - 1]);
	return 1;
}

void loop(void)
{
	int i, j, k;
	unsigned int t0, t, tb, tbm;

	try();
	t0 = timeit();
	printf("%u\n", t0);
	if (memcmp(out, exp_out, sizeof(out)))
		printf("%llx %llx %llx %llx\n", out[0], out[1], out[2], out[3]);

	for (j = 1; j < 100; j++)
	for (i = 6; i < incount - 1 - j; i++) {
		swap[i] = i + j;
		swap[i + j] = i;
		if (try())
			t = timeit();
		else
			t = 999;
		if (t < 999 && !memcmp(out, exp_out, sizeof(out))) {
			int a1 = i, a2 = i + j;
			tb = t; tbm = 9999;
			{
				int i, j;
				for (j = 1; j < 100; j++)
				for (i = 6; i < incount - 1 - j; i++) {
					unsigned int txm;
					int b1 = i, b2 = i + j;
					if (b1 == a1 || b1 == a2 || b2 == a1 || b2 == a2)
						continue;
					swap[i] = i + j;
					swap[i + j] = i;
					if (try())
						txm = timeit();
					else
						txm = 999;
					if (txm < 999 && !memcmp(out, exp_out, sizeof(out))) {
						int i, j;
						unsigned int tx;
						for (j = 1; j < 100; j++)
						for (i = 6; i < incount - 1 - j; i++) {
							int c1 = i, c2 = i + j;
							if (c1 == a1 || c1 == a2 ||
							    c2 == a1 || c2 == a2 ||
							    c1 == b1 || c1 == b2 ||
							    c2 == b1 || c2 == b2)
								continue;
							swap[i] = i + j;
							swap[i + j] = i;
							if (try())
								tx = timeit();
							else
								tx = 999;
							if (tx < tb &&
							    !memcmp(out, exp_out, sizeof(out))) {
								tb = tx;
								tbm = txm;
							}
							swap[i] = i;
							swap[i + j] = i + j;
						}
					}
					swap[i] = i;
					swap[i + j] = i + j;
				}
			}
			if (tb < t0) {
				printf("%d: %u,%u,%u - %d:", j, t, tbm, tb, i);
				for (k = 0; k < insizes[i]; k++)
					printf(" %02x", insns[i][k]);
				printf("\n");
			}
		}

		swap[i] = i;
		swap[i + j] = i + j;
	}
}

int main(void) {
	init();
	loop();

	return 0;
}
